Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# common_structures::graph_array< nodetype, arctype > Class Template Reference

`#include <graph_array.h>`

Inheritance diagram for common_structures::graph_array< nodetype, arctype >:

[legend]
List of all members.

## Public Types
typedef size_t | nodeid
typedef std::vector< node >::iterator | node_iterator
typedef std::vector< node >::const_iterator | const_node_iterator
typedef std::vector< node >::reverse_iterator | node_reverse_iterator
typedef std::vector< node >::const_reverse_iterator | const_node_reverse_iterator
typedef graph_array< nodetype, arctype > | _mytype
typedef std::list< arc >::iterator | out_arc_iterator
typedef std::list< arc >::const_iterator | const_out_arc_iterator
## Public Member Functions
| graph_array ()
| graph_array (const size_t NbNodes)
void | clear ()
bool | empty () const
void | setsize (const size_t NbNodes)
size_t | size () const
node & | operator[] (const nodeid &i)
const node & | operator[] (const nodeid &i) const
node_iterator | begin ()
node_iterator | end ()
const_node_iterator | begin () const
const_node_iterator | end () const
node_reverse_iterator | rbegin ()
node_reverse_iterator | rend ()
const_node_reverse_iterator | rbegin () const
const_node_reverse_iterator | rend () const
size_t | number_of_arcs () const
void | erase_arcs ()
void | erase_arcs (const node_iterator &Initial)
out_arc_iterator | erase_arc (const out_arc_iterator &Pos)
out_arc_iterator | insert_arc (const nodeid &Initial, const nodeid &Terminal)
out_arc_iterator | insert_arc (const nodeid &Initial, const nodeid &Terminal, const arctype &Elem)
out_arc_iterator | insert_arc (const node_iterator &Initial, const node_iterator &Terminal)
out_arc_iterator | insert_arc (const node_iterator &Initial, const node_iterator &Terminal, const arctype &Elem)
out_arc_iterator | insert (const nodeid &Initial, const nodeid &Terminal)
out_arc_iterator | insert (const nodeid &Initial, const nodeid &Terminal, const arctype &Elem)
out_arc_iterator | insert (const node_iterator &Initial, const node_iterator &Terminal)
out_arc_iterator | insert (const node_iterator &Initial, const node_iterator &Terminal, const arctype &Elem)
void | swap (_mytype &Right)
## Protected Attributes
size_t | m_NbArcs
std::vector< node > | m_Nodes
## Friends
void | swap (_mytype &Left, _mytype &Right)

### template<class nodetype, class arctype>
class common_structures::graph_array< nodetype, arctype >

## Member Typedef Documentation

template<class nodetype, class arctype>
typedef graph_array<nodetype, arctype> common_structures::graph_array< nodetype, arctype >::_mytype

template<class nodetype, class arctype>
typedef std::vector<node>::const_iterator common_structures::graph_array< nodetype, arctype >::const_node_iterator

template<class nodetype, class arctype>
typedef std::vector<node>::const_reverse_iterator common_structures::graph_array< nodetype, arctype >::const_node_reverse_iterator

template<class nodetype, class arctype>
typedef std::list<arc>::const_iterator common_structures::graph_array< nodetype, arctype >::const_out_arc_iterator

template<class nodetype, class arctype>
typedef std::vector<node>::iterator common_structures::graph_array< nodetype, arctype >::node_iterator

template<class nodetype, class arctype>
typedef std::vector<node>::reverse_iterator common_structures::graph_array< nodetype, arctype >::node_reverse_iterator

template<class nodetype, class arctype>
typedef size_t common_structures::graph_array< nodetype, arctype >::nodeid

template<class nodetype, class arctype>
typedef std::list<arc>::iterator common_structures::graph_array< nodetype, arctype >::out_arc_iterator

## Constructor & Destructor Documentation

template<class nodetype, class arctype>
common_structures::graph_array< nodetype, arctype >::graph_array | ( |  | ) | `[inline]`

template<class nodetype, class arctype>
common_structures::graph_array< nodetype, arctype >::graph_array | ( | const size_t | NbNodes | ) | `[inline, explicit]`

## Member Function Documentation

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::const_node_iterator common_structures::graph_array< nodetype, arctype >::begin | ( |  | ) | const`[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::node_iterator common_structures::graph_array< nodetype, arctype >::begin | ( |  | ) | `[inline]`

template<class nodetype, class arctype>
void common_structures::graph_array< nodetype, arctype >::clear | ( |  | ) | `[inline]`

template<class nodetype, class arctype>
bool common_structures::graph_array< nodetype, arctype >::empty | ( |  | ) | const`[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::const_node_iterator common_structures::graph_array< nodetype, arctype >::end | ( |  | ) | const`[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::node_iterator common_structures::graph_array< nodetype, arctype >::end | ( |  | ) | `[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::out_arc_iterator common_structures::graph_array< nodetype, arctype >::erase_arc | ( | const out_arc_iterator & | Pos | ) | `[inline]`

template<class nodetype, class arctype>
void common_structures::graph_array< nodetype, arctype >::erase_arcs | ( | const node_iterator & | Initial | ) | `[inline]`

template<class nodetype, class arctype>
void common_structures::graph_array< nodetype, arctype >::erase_arcs | ( |  | ) | `[inline]`

template<class nodetype, class arctype>
out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert | ( | const node_iterator & | Initial,
|  | const node_iterator & | Terminal,
|  | const arctype & | Elem
| ) | `[inline]`

template<class nodetype, class arctype>
out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert | ( | const node_iterator & | Initial,
|  | const node_iterator & | Terminal
| ) | `[inline]`

template<class nodetype, class arctype>
out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert | ( | const nodeid & | Initial,
|  | const nodeid & | Terminal,
|  | const arctype & | Elem
| ) | `[inline]`

template<class nodetype, class arctype>
out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert | ( | const nodeid & | Initial,
|  | const nodeid & | Terminal
| ) | `[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert_arc | ( | const node_iterator & | Initial,
|  | const node_iterator & | Terminal,
|  | const arctype & | Elem
| ) | `[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert_arc | ( | const node_iterator & | Initial,
|  | const node_iterator & | Terminal
| ) | `[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert_arc | ( | const nodeid & | Initial,
|  | const nodeid & | Terminal,
|  | const arctype & | Elem
| ) | `[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::out_arc_iterator common_structures::graph_array< nodetype, arctype >::insert_arc | ( | const nodeid & | Initial,
|  | const nodeid & | Terminal
| ) | `[inline]`

template<class nodetype, class arctype>
size_t common_structures::graph_array< nodetype, arctype >::number_of_arcs | ( |  | ) | const`[inline]`

template<class nodetype, class arctype>
const graph_array< nodetype, arctype >::node & common_structures::graph_array< nodetype, arctype >::operator[] | ( | const nodeid & | i | ) | const`[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::node & common_structures::graph_array< nodetype, arctype >::operator[] | ( | const nodeid & | i | ) | `[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::const_node_reverse_iterator common_structures::graph_array< nodetype, arctype >::rbegin | ( |  | ) | const`[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::node_reverse_iterator common_structures::graph_array< nodetype, arctype >::rbegin | ( |  | ) | `[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::const_node_reverse_iterator common_structures::graph_array< nodetype, arctype >::rend | ( |  | ) | const`[inline]`

template<class nodetype, class arctype>
graph_array< nodetype, arctype >::node_reverse_iterator common_structures::graph_array< nodetype, arctype >::rend | ( |  | ) | `[inline]`

template<class nodetype, class arctype>
void common_structures::graph_array< nodetype, arctype >::setsize | ( | const size_t | NbNodes | ) | `[inline]`

template<class nodetype, class arctype>
size_t common_structures::graph_array< nodetype, arctype >::size | ( |  | ) | const`[inline]`

template<class nodetype, class arctype>
void common_structures::graph_array< nodetype, arctype >::swap | ( | _mytype & | Right | ) | `[inline]`

## Friends And Related Function Documentation

template<class nodetype, class arctype>
void swap | ( | _mytype & | Left,
|  | _mytype & | Right
| ) | `[friend]`

## Member Data Documentation

template<class nodetype, class arctype>
size_t common_structures::graph_array< nodetype, arctype >::m_NbArcs`[protected]`

template<class nodetype, class arctype>
std::vector<node> common_structures::graph_array< nodetype, arctype >::m_Nodes`[protected]`

The documentation for this class was generated from the following file:

- graph_array.h